> ## Documentation Index
> Fetch the complete documentation index at: https://docs.topsort.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Json Template

> Endpoint to create a new JSON template.



## OpenAPI

````yaml /openapi.json post /public/v1/campaign-service/json-templates
openapi: 3.1.0
info:
  title: Topsort Endpoints v2 API Reference
  description: >
    In order for a storefront to be able to run auctions in Topsort and report
    auction-related events back to Topsort,

    both the `/v2/auctions` and `/v2/events` endpoints must be integrated.

    Below are the endpoint and model definitions for each.
  contact:
    email: wicha@topsort.com
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0.html
  x-logo:
    url: https://assets.topsort.com/Topsort_logo_icon_dark.svg
    backgroundColor: '#fff'
    altText: Topsort
  version: 2.0.0
servers:
  - url: https://api.topsort.com
    description: Base API URL
security: []
tags:
  - name: Auctions
    description: >-
      An auction determines which products should be promoted based on the
      vendors' bids.
  - name: Events
    description: >-
      Events are sent to Topsort as part of the attribution and reporting
      journey.
  - name: Toptimize
    description: >
      An out-of-the-box solution for prediction, ranking, retrieval, and other
      elements of ad selection.
  - name: Toppie API
    description: Toppie management API.
  - name: Campaign API
    description: Full-featured campaign management API for banners and sponsored listings.
  - name: Catalog API
    description: Products catalog management API.
  - name: Billing API
    description: Marketplace and Vendor Billing management API.
  - name: Reporting API
    description: Marketplace, Vendor, Campaign, and product reporting API.
  - name: Invitation API
    description: Vendor invitations management API.
  - name: User API
    description: User management API.
  - name: Webhooks API
    description: Webhooks API that allows event-driven automation.
  - name: Assets API
    description: Assets management API.
  - name: Segments Service
    description: Segments Service.
  - name: Forecasting Service
    description: Toptimize Forecasting Service.
  - name: Offsite Ads API
    description: Offsite Ads API that allows to manage offsite ads campaigns.
  - name: Media API
    description: Ad configuration API.
paths:
  /public/v1/campaign-service/json-templates:
    post:
      tags:
        - Campaign API
      summary: Create Json Template
      description: Endpoint to create a new JSON template.
      operationId: create_json_template
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/Advanced_APIs_JsonTemplateCreateRequest'
      responses:
        '201':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Advanced_APIs_JsonTemplate'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Advanced_APIs_HTTPValidationError'
      security:
        - Advanced_APIs_HTTPBearer: []
components:
  schemas:
    Advanced_APIs_JsonTemplateCreateRequest:
      properties:
        name:
          type: string
          maxLength: 50
          minLength: 1
          title: Name
          description: Unique name of the JSON template
        description:
          type: string
          maxLength: 100
          minLength: 1
          title: Description
          description: Description of the JSON template
        previewScreenshot:
          title: Previewscreenshot
          description: Preview screenshot of the JSON template
          oneOf:
            - type: string
              maxLength: 2083
              minLength: 1
              format: uri
            - type: 'null'
        adFormat:
          description: AdFormat this template is for
          default: banner
          oneOf:
            - $ref: '#/components/schemas/Advanced_APIs_JsonTemplateAdFormat'
            - type: 'null'
        previewUrl:
          title: Previewurl
          description: Preview URL of the JSON template
          oneOf:
            - type: string
              maxLength: 2083
              minLength: 1
              format: uri
            - type: 'null'
        jsonSchema:
          additionalProperties: true
          type: object
          title: Jsonschema
          description: >-
            A JSON object that defines a schema according to draft-07 of the
            JSON Schema specification.
          examples:
            - $schema: http://json-schema.org/draft-07/schema#
              properties:
                title:
                  maxLength: 100
                  minLength: 1
                  type: string
              required:
                - title
              type: object
      type: object
      required:
        - name
        - description
        - jsonSchema
      title: JsonTemplateCreateRequest
    Advanced_APIs_JsonTemplate:
      properties:
        id:
          type: string
          format: uuid
          title: Id
          description: The ID of the JSON template
        marketplaceId:
          type: string
          format: uuid
          title: Marketplaceid
          description: The ID of the marketplace
        name:
          type: string
          title: Name
          description: The name of the JSON template
        description:
          type: string
          title: Description
          description: The description of the JSON template
        isArchived:
          type: boolean
          title: Isarchived
          description: Whether the JSON template is archived
          default: false
        previewScreenshot:
          title: Previewscreenshot
          description: Preview screenshot of the JSON template
          oneOf:
            - type: string
              maxLength: 2083
              minLength: 1
              format: uri
            - type: 'null'
        previewUrl:
          title: Previewurl
          description: Preview URL of the JSON template
          oneOf:
            - type: string
              maxLength: 2083
              minLength: 1
              format: uri
            - type: 'null'
        jsonSchema:
          additionalProperties: true
          type: object
          title: Jsonschema
          description: The JSON schema of the JSON template
        createdAt:
          type: string
          format: date-time
          title: Createdat
          description: The creation time of the JSON template
        updatedAt:
          type: string
          format: date-time
          title: Updatedat
          description: The update time of the JSON template
        adFormat:
          $ref: '#/components/schemas/Advanced_APIs_JsonTemplateAdFormat'
          description: The ad format of the JSON template
      type: object
      required:
        - id
        - marketplaceId
        - name
        - description
        - jsonSchema
        - createdAt
        - updatedAt
        - adFormat
      title: JsonTemplate
    Advanced_APIs_HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Advanced_APIs_ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    Advanced_APIs_JsonTemplateAdFormat:
      type: string
      enum:
        - banner
        - sponsored_brand
      title: JsonTemplateAdFormat
      description: The type of the ad format of the JSON template.
    Advanced_APIs_ValidationError:
      properties:
        loc:
          items:
            oneOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    Advanced_APIs_HTTPBearer:
      type: http
      description: >-
        A valid API key generated in Topsort's UI. Use the TSE API key if
        calling auctions or events API, otherwise use the TSC API key.
      scheme: bearer

````